%% measure focal length
% measurement based on manual measurements of image features

%%

clear
close all
load imgdata

%%

sz = size(files);
N = sz(1);
for m=1:N
    subplot(3,3,m);
    rgb = imread(files(m,:));
    sz = size(rgb);
    small = imcrop(rgb,[sz(1)/4 sz(2)/4 512 512]);
    g = rgb2gray(im2double(small));
    imshow(g);
    hold on
    plot(data(:,1,m),data(:,2,m),'yo');
    hold off
    fprintf('image %d threshold %g width %g\n',m,graythresh(g),data(2,1,m)-data(1,1,m));
end

%%

subplot(1,1,1);
imhist(g);
hold on
thres = graythresh(g);
plot([thres thres],[0 4000],'k--','LineWidth',2);
hold off

%%

name = files(1,:);
caminfo;

%%

w = 2*5.3; % cm, width of two squares
diff = data(2,1,:)-data(1,1,:);
width = diff(:);
% camera shutter did not trigger at a couple of stops
zcm = zinches([2:3,5:11])*2.54;
y = w./width;
subplot(1,1,1);
plot(zcm,y,'ko');
grid;
xlabel('distance (cm)');
ylabel('actual/measured (cm/pixel)');
ndx = 3:length(zcm);
c1 = polyfit(zcm(ndx),y(ndx),1);
hold on
xr = [0 600];
plot(xr,polyval(c1,xr),'k','LineWidth',2);
hold off
fprintf('effective focal length %g pixels\n',1/c1(1));



